﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using SqliteUsingSQLiteWinRT.ViewModels;
using System.Runtime.InteropServices;

namespace SqliteUsingSQLiteWinRT.Views
{
  public partial class ProjectView : PhoneApplicationPage
  {
    private ProjectViewModel viewModel;

    public ProjectView()
    {
      InitializeComponent();
    }

    protected async override void OnNavigatedTo(NavigationEventArgs e)
    {
      string value;
      if (!NavigationContext.QueryString.TryGetValue("ID", out value))
        throw new InvalidOperationException("Must supply an Id");

      try
      {
        viewModel = await ProjectsViewModel.GetDefault().GetItemAsync(Int32.Parse(value));
        this.DataContext = viewModel;
      }
      catch (Exception ex)
      {
        MessageBox.Show("Can't find that item: " + ex.Message + ". " + SQLiteWinRT.Database.GetSqliteErrorCode(ex.HResult));
      }
    }

    private void EditButton_Click(object sender, EventArgs e)
    {
      NavigationService.Navigate(new Uri("/Views/ProjectEditView.xaml?ID=" + viewModel.Id, UriKind.Relative));
    }

    private async void DeleteButton_Click(object sender, EventArgs e)
    {
      try
      {
        await ProjectsViewModel.GetDefault().DeleteItemAsync(viewModel.Id);
        if (NavigationService.CanGoBack)
          NavigationService.GoBack();
        else
          DataContext = null;
      }
      catch(Exception ex)
      {
        MessageBox.Show("Can't delete that item: " + ex.Message + ". " + SQLiteWinRT.Database.GetSqliteErrorCode(ex.HResult));
      }
    }
  }
}